#!/bin/bash
#=========================================================================
#
# USAGE
#  ./GET_RESTART.sh $BEG_ID:$END_ID $RESTART_DATE $TYP:$LTRIP $RESDIR $RUNDIR
#
# BEG_ID       : the begin id of a job
# END_ID       : the end id of a job
# BEG_DATE     : the date for restart
# TYP          : the type of a run
# RESDIR       : storing directory on hendrix
# RUNDIR       : local directory
#
#=========================================================================
#

BEG_ID=`echo $1 | awk '{split($1, f, ":"); print f[1]}'`
END_ID=`echo $1 | awk '{split($1, f, ":"); print f[2]}'`
RESTART_DATE=$2
TYP=`echo $3 | awk '{split($1, f, ":"); print f[1]}'`
LTRIP=`echo $3 | awk '{split($1, f, ":"); print f[2]}'`
RESDIR=$4
RUNDIR=$5

#can not decompress on the fly because the latest version (4.8.1) of lftp is not happy with "-o /dev/stdout". I have no idea because the old version can do that
#lftp hendrix -e "get $RESDIR/RESTART_${RESTART_DATE}.tar.gz -o /dev/stdout; quit" 2>/dev/null | pigz -dq | tar xf - 2>/dev/null
#rc=$?
lftp hendrix -e "get -c $RESDIR/RESTART_${RESTART_DATE}.tar.gz -o RESTART_${RESTART_DATE}.tar.gz; quit" 2>/dev/null
rc=$?
if [ $rc -eq 0 ]; then
  echo "got restart files from hendrix:$RESDIR/RESTART_${RESTART_DATE}.tar.gz"
  tar zxf RESTART_${RESTART_DATE}.tar.gz 2>/dev/null
  rc=$?
  rm -f RESTART_${RESTART_DATE}.tar.gz
fi
if [ $rc -eq 0 ]; then
  NRUN=0
  [ "$TYP" = "ENKF" -o "$TYP" = "ENOL" ] && NRUN=$END_ID

  NINI=`ls PREP_${RESTART_DATE}_*.nc 2> /dev/null | wc -l`
  if [[ ( $NINI -eq 1 && $NRUN -eq 0 ) || ( $NINI -eq $NRUN ) ]]; then
    IRUN=$BEG_ID
    while [ $IRUN -le $NRUN ]; do
      mv -f PREP_${RESTART_DATE}_$IRUN.nc PREP_$IRUN.nc
      if [ $LTRIP -eq 1 ]; then
        mv -f TRIP_PREP_${RESTART_DATE}_$IRUN.nc TRIP_PREP_$IRUN.nc
        mv -f lsm_${RESTART_DATE}_$IRUN.nc lsm_$IRUN.nc
        mv -f trip_${RESTART_DATE}_$IRUN.nc trip_$IRUN.nc
      fi
      IRUN=$((IRUN+1))
    done
  else
    IRUN=$BEG_ID
    while [ $IRUN -le $NRUN ]; do
      [ -f PREP_${RESTART_DATE}.nc ] && ln -f PREP_${RESTART_DATE}.nc PREP_$IRUN.nc
      if [ $LTRIP -eq 1 ]; then
        [ -f TRIP_PREP_${RESTART_DATE}.nc ] && ln -f TRIP_PREP_${RESTART_DATE}.nc TRIP_PREP_$IRUN.nc
        [ -f lsm_${RESTART_DATE}.nc ] && cp -f lsm_${RESTART_DATE}.nc lsm_$IRUN.nc
        [ -f trip_${RESTART_DATE}.nc ] && cp -f trip_${RESTART_DATE}.nc trip_$IRUN.nc
      fi
      IRUN=$((IRUN+1))
    done
  fi
else
  # noting that we using copy instead of link so that the run will not overwrite the original files
  NRUN=0
  [ "$TYP" = "ENKF" -o "$TYP" = "ENOL" ] && NRUN=$END_ID
  IRUN=$BEG_ID
  while [ $IRUN -le $NRUN ]; do
    [ -f $RUNDIR/pgd_prep/PREP_${RESTART_DATE}.nc ] && ln -sf $RUNDIR/pgd_prep/PREP_${RESTART_DATE}.nc PREP_$IRUN.nc
    if [ $LTRIP -eq 1 ]; then
      [ -f $RUNDIR/pgd_prep/TRIP_PREP_${RESTART_DATE}.nc ] && ln -sf $RUNDIR/pgd_prep/TRIP_PREP_${RESTART_DATE}.nc TRIP_PREP_$IRUN.nc
      [ -f $RUNDIR/pgd_prep/lsm_${RESTART_DATE}.nc ] && cp -f $RUNDIR/pgd_prep/lsm_${RESTART_DATE}.nc lsm_$IRUN.nc
      [ -f $RUNDIR/pgd_prep/trip_${RESTART_DATE}.nc ] && cp -f $RUNDIR/pgd_prep/trip_${RESTART_DATE}.nc trip_$IRUN.nc
    fi
    IRUN=$((IRUN+1))
  done
fi

