#!/bin/bash
#=========================================================================
#
# USAGE
#   ./SET_OPTIONS.sh OPTIONSNAM TYP LASSIM LPRT NIVAR PREP
#
# OPTIONSNAM : filename of the SURFEX options namelist
# TYP        : 'OL', 'EKF', 'ENKF'
# LASSIM     : T if assimilation, F else
  # LPRT     : T if perturbed run, F else
  # NIVAR    : variable id for perturbed run
# or
  # LENS_GEN : T if generated an ensemble
  # NIE      : member id for ensemble run
# PREP       : filename of the SURFEX PREP file
#
# by default ./SET_OPTIONS.sh is equivalent to:
#   ./SET_OPTIONS.sh OPTIONS.nam OL F F 1 PREP
#
#=========================================================================
#
OPTIONSNAM=${1:-OPTIONS.nam}
TYP=${2:-OL}
sed -i "s/XXX-LASSIM-XXX/${3:-F}/" $OPTIONSNAM
if [ "$TYP" = "ENKF" ]; then
  sed -i "s/XXX-LENS_GEN-XXX/${4:-F}/" $OPTIONSNAM
  sed -i "s/XXX-NIE-XXX/${5:-1}/" $OPTIONSNAM
  sed -i "s/XXX-LPRT-XXX/F/" $OPTIONSNAM
  sed -i "s/XXX-NIVAR-XXX/1/" $OPTIONSNAM
else
  sed -i "s/XXX-LENS_GEN-XXX/F/" $OPTIONSNAM
  sed -i "s/XXX-NIE-XXX/1/" $OPTIONSNAM
  sed -i "s/XXX-LPRT-XXX/${4:-F}/" $OPTIONSNAM
  sed -i "s/XXX-NIVAR-XXX/${5:-1}/" $OPTIONSNAM
fi
sed -i "s/XXX-CPREPFILE-XXX/${6:-PREP}/" $OPTIONSNAM

