#!/bin/bash

if [ $# -lt 1 ] ; then
  echo 'USAGE: copy_restart $expname'
  echo '  will copy restart files from EXP/$expname to pgd_prep/'
  exit
fi
#
exp=$1
[ ! -d EXP/$exp ] && echo "Experiment EXP/$exp does not exist" && exit 1
maindir=$(pwd)
#
# Check dates
cd EXP/$exp

FID=_0
YEAR=`ncdump -v DTCUR-YEAR PREP${FID}.nc | grep 'DTCUR-YEAR = ' | awk '{print $3}'`
MONTH=`ncdump -v DTCUR-MONTH PREP${FID}.nc | grep 'DTCUR-MONTH = ' | awk '{print $3}'`
DAY=`ncdump -v DTCUR-DAY PREP${FID}.nc | grep 'DTCUR-DAY = ' | awk '{print $3}'`
TIME=`ncdump -v DTCUR-TIME PREP${FID}.nc | grep 'DTCUR-TIME = ' | awk '{print $3}'`
DAT=`echo "$YEAR $MONTH $DAY $TIME" | awk '{printf "%4d%02d%02d%02d",$1,$2,$3,$4/3600}'`

# Check if restart files exist for this date
EX=0
[ -f PREP${FID}.nc ] && [ -f $maindir/pgd_prep/PREP_$DAT.nc ] && EX=1
[ -f TRIP_PREP${FID}.nc ] && [ -f $maindir/pgd_prep/TRIP_PREP_$DAT.nc ] && EX=1
[ -f lsm${FID}.nc ] && [ -f $maindir/pgd_prep/lsm_$DAT.nc ] && EX=1
[ -f trip${FID}.nc ] && [ -f $maindir/pgd_prep/trip_$DAT.nc ] && EX=1
if [ $EX -gt 0 ] ; then
  read -p "Restart files already exist for date $DAT. Overwrite? ([y]/n) " tmp
  [[ $tmp == [Nn]* ]] && exit
fi
# Move files
[ -f PREP${FID}.nc ] && mv PREP${FID}.nc $maindir/pgd_prep/PREP_$DAT.nc && echo "PREP_$DAT.nc moved"
[ -f TRIP_PREP${FID}.nc ] && mv TRIP_PREP${FID}.nc $maindir/pgd_prep/TRIP_PREP_$DAT.nc && echo "TRIP_PREP_$DAT.nc moved"
[ -f lsm${FID}.nc ] && mv lsm${FID}.nc $maindir/pgd_prep/lsm_$DAT.nc && echo "lsm_$DAT.nc moved"
[ -f trip${FID}.nc ] && mv trip${FID}.nc $maindir/pgd_prep/trip_$DAT.nc && echo "trip_$DAT.nc moved"

